| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
EM::Horizon2DGeometry Class Reference
EarthModel

2D HorizonGeometry More...

`#include <emhorizon2d.h>`

Inheritance diagram for EM::Horizon2DGeometry:
[legend]

## Public Member Functions
| Horizon2DGeometry (Surface &)
| ~Horizon2DGeometry ()
bool | addLine (const Pos::GeomID &, const StepInterval< int > &trcrg)
bool | addLine (const Pos::GeomID &, int step=1)
StepInterval< int > | colRange (const Pos::GeomID &) const
StepInterval< int > | colRange (const SectionID &, const Pos::GeomID &geomid) const
const Geometry::Horizon2DLine * | geometryElement () const override
Geometry::Horizon2DLine * | geometryElement () override
Pos::GeomID | geomID (int idx) const
int | getConnectedPos (const PosID &posid, TypeSet< PosID > *res) const override
void | getGeomIDs (TypeSet< Pos::GeomID > &) const
PosID | getNeighbor (const PosID &posid, bool nextcol, bool retundef=false) const
PosID | getPosID (const TrcKey &) const override
TrcKey | getTrcKey (const PosID &) const override
bool | hasLine (const Pos::GeomID &) const
bool | includeLine (const Pos::GeomID &, int step=1)
bool | isAtEdge (const PosID &) const override
int | lineIndex (const char *linenm) const
int | lineIndex (const Pos::GeomID &) const
const char * | lineName (int id) const
const char * | lineSet (int id) const
int | nrLines () const
void | removeLine (const Pos::GeomID &)
const Geometry::Horizon2DLine * | sectionGeometry (const SectionID &) const override
Geometry::Horizon2DLine * | sectionGeometry (const SectionID &) override
Public Member Functions inherited from EM::HorizonGeometry
| ~HorizonGeometry ()
Public Member Functions inherited from EM::RowColSurfaceGeometry
| RowColSurfaceGeometry (Surface &)
virtual | ~RowColSurfaceGeometry ()
StepInterval< int > | colRange () const
StepInterval< int > | colRange (const SectionID &, int row) const
StepInterval< int > | colRange (int row) const
EMObjectIterator * | createIterator (const TrcKeyZSampling *=nullptr) const override
const Geometry::RowColSurface * | geometryElement () const override
Geometry::RowColSurface * | geometryElement () override
StepInterval< int > | rowRange () const
StepInterval< int > | rowRange (const SectionID &) const
const Geometry::RowColSurface * | sectionGeometry (const SectionID &) const override
Geometry::RowColSurface * | sectionGeometry (const SectionID &) override
Public Member Functions inherited from EM::SurfaceGeometry
virtual | ~SurfaceGeometry ()
mDeprecatedObs SectionID | addSection (const char *nm, bool addtohistory)
mDeprecatedObs SectionID | addSection (const char *nm, const SectionID &, bool addtohistory)
virtual mDeprecatedObs SectionID | cloneSection (const SectionID &)
EMObjectIterator * | createIterator (const EM::SectionID &, const TrcKeyZSampling *t=0) const
virtual bool | enableChecks (bool yn)
virtual int | findPos (const Interval< float > &x, const Interval< float > &y, const Interval< float > &z, TypeSet< PosID > *) const
virtual mDeprecatedDef int | findPos (const SectionID &, const Interval< float > &x, const Interval< float > &y, const Interval< float > &z, TypeSet< PosID > *res) const
virtual int | findPos (const TrcKeyZSampling &, TypeSet< PosID > *) const
virtual void | getLinkedPos (const PosID &posid, TypeSet< PosID > &) const
mDeprecatedObs bool | hasSection (const SectionID &) const
bool | isChanged (int) const
virtual bool | isChecksEnabled () const
virtual bool | isFullResolution () const
virtual bool | isLoaded () const
virtual bool | isNodeOK (const PosID &) const
virtual Executor * | loader (const SurfaceIODataSelection *=nullptr)
int | nrSections () const
virtual void | removeAll ()
virtual mDeprecatedObs bool | removeSection (const SectionID &, bool addtohistory)
void | resetChangedFlag ()
virtual Executor * | saver (const SurfaceIODataSelection *=nullptr, const MultiID *=nullptr)
mDeprecatedObs SectionID | sectionID (const char *) const
mDeprecatedObs SectionID | sectionID (int idx) const
mDeprecatedObs int | sectionIndex (const SectionID &) const
mDeprecatedObs const char * | sectionName (const SectionID &) const
mDeprecatedObs bool | setSectionName (const SectionID &, const char *, bool addtohistory)
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()

## Static Public Member Functions
static const char * | sKeyID ()
static const char * | sKeyLineIDs ()
static const char * | sKeyLineNames ()
static const char * | sKeyLineSets ()
static const char * | sKeyNrLines ()
static const char * | sKeyTraceRange ()
static const char * | sKeyTrcRg ()
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()

## Protected Member Functions
Geometry::Horizon2DLine * | createGeometryElement () const override
bool | doAddLine (const Pos::GeomID &geomid, const StepInterval< int > &trcrg, bool mergewithdouble)
void | fillPar (IOPar &) const override
bool | usePar (const IOPar &) override
Protected Member Functions inherited from EM::HorizonGeometry
| HorizonGeometry (Surface &)
Protected Member Functions inherited from EM::SurfaceGeometry
| SurfaceGeometry (Surface &)
mDeprecatedObs SectionID | addSectionInternal (Geometry::Element *, const char *nm, const SectionID &, bool addtohistory)
void | geomChangeCB (CallBacker *)

## Additional Inherited Members
Protected Attributes inherited from EM::SurfaceGeometry
bool | changed_
ObjectSet< Geometry::Element > | sections_
Surface & | surface_

## Detailed Description

2D HorizonGeometry

<>

## Constructor & Destructor Documentation

## ◆ Horizon2DGeometry()

EM::Horizon2DGeometry::Horizon2DGeometry | ( | Surface & |  | ) |

## ◆ ~Horizon2DGeometry()

EM::Horizon2DGeometry::~Horizon2DGeometry | ( |  | ) |

## Member Function Documentation

## ◆ addLine() [1/2]

bool EM::Horizon2DGeometry::addLine | ( | const Pos::GeomID & | ,
|  | const StepInterval< int > & | trcrg )

## ◆ addLine() [2/2]

bool EM::Horizon2DGeometry::addLine | ( | const Pos::GeomID & | ,
|  | int | step = 1 )

## ◆ colRange() [1/2]

StepInterval< int > EM::Horizon2DGeometry::colRange | ( | const Pos::GeomID & |  | ) | const

## ◆ colRange() [2/2]

StepInterval< int > EM::Horizon2DGeometry::colRange | ( | const SectionID & | ,
|  | const Pos::GeomID & | geomid ) const
| inline

## ◆ createGeometryElement()

Geometry::Horizon2DLine * EM::Horizon2DGeometry::createGeometryElement | ( |  | ) | const
| override protected virtual

Implements EM::SurfaceGeometry.

## ◆ doAddLine()

bool EM::Horizon2DGeometry::doAddLine | ( | const Pos::GeomID & | geomid,
|  | const StepInterval< int > & | trcrg,
|  | bool | mergewithdouble )
| protected

## ◆ fillPar()

void EM::Horizon2DGeometry::fillPar | ( | IOPar & |  | ) | const
| override protected virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ geometryElement() [1/2]

const Geometry::Horizon2DLine * EM::Horizon2DGeometry::geometryElement | ( |  | ) | const
| override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ geometryElement() [2/2]

Geometry::Horizon2DLine * EM::Horizon2DGeometry::geometryElement | ( |  | ) |
| override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ geomID()

Pos::GeomID EM::Horizon2DGeometry::geomID | ( | int | idx | ) | const

## ◆ getConnectedPos()

int EM::Horizon2DGeometry::getConnectedPos | ( | const PosID & | posid,
|  | TypeSet< PosID > * | res ) const
| override virtual

Returns
  the number of connected pos.

Reimplemented from EM::SurfaceGeometry.

## ◆ getGeomIDs()

void EM::Horizon2DGeometry::getGeomIDs | ( | TypeSet< Pos::GeomID > & |  | ) | const

## ◆ getNeighbor()

PosID EM::Horizon2DGeometry::getNeighbor | ( | const PosID & | posid,
|  | bool | nextcol,
|  | bool | retundef = false ) const

Parameters

  posid |
  nextcol |
  retundef | specifies what to do if no neighbor is found. If it true, it returnes unf, if not it return the id of the undef neighbor.

## ◆ getPosID()

PosID EM::Horizon2DGeometry::getPosID | ( | const TrcKey & |  | ) | const
| override virtual

Implements EM::HorizonGeometry.

## ◆ getTrcKey()

TrcKey EM::Horizon2DGeometry::getTrcKey | ( | const PosID & |  | ) | const
| override virtual

Implements EM::HorizonGeometry.

## ◆ hasLine()

bool EM::Horizon2DGeometry::hasLine | ( | const Pos::GeomID & |  | ) | const

## ◆ includeLine()

bool EM::Horizon2DGeometry::includeLine | ( | const Pos::GeomID & | ,
|  | int | step = 1 )

## ◆ isAtEdge()

bool EM::Horizon2DGeometry::isAtEdge | ( | const PosID & |  | ) | const
| override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ lineIndex() [1/2]

int EM::Horizon2DGeometry::lineIndex | ( | const char * | linenm | ) | const

## ◆ lineIndex() [2/2]

int EM::Horizon2DGeometry::lineIndex | ( | const Pos::GeomID & |  | ) | const

## ◆ lineName()

const char * EM::Horizon2DGeometry::lineName | ( | int | id | ) | const

## ◆ lineSet()

const char * EM::Horizon2DGeometry::lineSet | ( | int | id | ) | const

## ◆ nrLines()

int EM::Horizon2DGeometry::nrLines | ( |  | ) | const

## ◆ removeLine()

void EM::Horizon2DGeometry::removeLine | ( | const Pos::GeomID & |  | ) |

## ◆ sectionGeometry() [1/2]

const Geometry::Horizon2DLine * EM::Horizon2DGeometry::sectionGeometry | ( | const SectionID & |  | ) | const
| inline override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ sectionGeometry() [2/2]

Geometry::Horizon2DLine * EM::Horizon2DGeometry::sectionGeometry | ( | const SectionID & |  | ) |
| inline override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ sKeyID()

static const char * EM::Horizon2DGeometry::sKeyID | ( |  | ) |
| inline static

## ◆ sKeyLineIDs()

static const char * EM::Horizon2DGeometry::sKeyLineIDs | ( |  | ) |
| inline static

## ◆ sKeyLineNames()

static const char * EM::Horizon2DGeometry::sKeyLineNames | ( |  | ) |
| inline static

## ◆ sKeyLineSets()

static const char * EM::Horizon2DGeometry::sKeyLineSets | ( |  | ) |
| inline static

## ◆ sKeyNrLines()

static const char * EM::Horizon2DGeometry::sKeyNrLines | ( |  | ) |
| inline static

## ◆ sKeyTraceRange()

static const char * EM::Horizon2DGeometry::sKeyTraceRange | ( |  | ) |
| inline static

## ◆ sKeyTrcRg()

static const char * EM::Horizon2DGeometry::sKeyTrcRg | ( |  | ) |
| inline static

## ◆ usePar()

bool EM::Horizon2DGeometry::usePar | ( | const IOPar & |  | ) |
| override protected virtual

Reimplemented from EM::SurfaceGeometry.

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025